// @author: Tom de Qu'est-ce que tu GEEKes ?
// This script takes an address as input and scans all ports available to find vulnerabilities
// Collect inputs and handling options
if params.len < 1 or params[0] == "-h" or params[0] == "--help" then exit("<b>Usage: "+program_path.split("/")[-1]+" [ip_address]</b>")

//print("<color=#f4ae34>QTG ORANGE</color>")
//print("<color=#1a508d>QTG BLUE</color>")
//print("<color=#182d53>QTG DARK BLUE</color>")

print(char(10))
print("UnivScan By:"+ char(10))
print("<color=#1a508d>      &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&     </color>")
print("<color=#1a508d> &%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% </color>")
print("<color=#1a508d>&%%%%                                                                       %%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&       <color=#f4ae34>,***,***,***,***,                            ***,***,***,***,*</color>  &%%%</color>")
print("<color=#1a508d>&%%%&       <color=#f4ae34>*</color>%%%%%%%%%%%%%%<color=#f4ae34>**</color>                            <color=#f4ae34>**</color>%%%%%%%%%%%%%<color=#f4ae34>**</color>  &%%%</color>")
print("<color=#1a508d>&%%%&  <color=#f4ae34>******</color>%%%%%%%%%%%%%%<color=#f4ae34>*****, **************,** *******</color>%%%%%%%%%%%%%<color=#f4ae34>**</color>  &%%%</color>")
print("<color=#1a508d>&%%%&  <color=#f4ae34>**</color>%%%%%<color=#f4ae34>*,         **</color>%%%%<color=#f4ae34>*, **</color>%%%%%%%%%%%%%<color=#f4ae34>** **</color>%%%%%<color=#f4ae34>**</color>               &%%%</color>")
print("<color=#1a508d>&%%%&  <color=#f4ae34>*,</color>%%%%%<color=#f4ae34>*,         **</color>%%%%<color=#f4ae34>*, ******,</color>%%%%<color=#f4ae34>***,** **</color>%%%%%<color=#f4ae34>****</color>%%%%<color=#f4ae34>**</color>       &%%%</color>")
print("<color=#1a508d>&%%%&  <color=#f4ae34>**</color>%%%%%<color=#f4ae34>*,******** **</color>%%%%<color=#f4ae34>*,      **</color>%%%%<color=#f4ae34>**     **</color>%%%%%<color=#f4ae34>****</color>%%%%<color=#f4ae34>*******</color>  &%%%</color>")
print("<color=#1a508d>&%%%&  <color=#f4ae34>**</color>%%%%%<color=#f4ae34>*,,*</color>%%%%<color=#f4ae34>** **</color>%%%%<color=#f4ae34>*,      **</color>%%%%<color=#f4ae34>**     **</color>%%%%%<color=#f4ae34>*****,**</color>%%%%%<color=#f4ae34>**</color>  &%%%</color>")
print("<color=#1a508d>&%%%&  <color=#f4ae34>**</color>%%%%%<color=#f4ae34>****</color>%%%%<color=#f4ae34>*****</color>%%%%<color=#f4ae34>*,      **</color>%%%%<color=#f4ae34>**     **</color>%%%%%<color=#f4ae34>*****,**</color>%%%%%<color=#f4ae34>**</color>  &%%%</color>")
print("<color=#1a508d>&%%%&  <color=#f4ae34>*,*,*,</color>*%%%%%%%%%%%%%<color=#f4ae34>*,*,*,      *,</color>%%%%<color=#f4ae34>*,     ,*,*,*,</color>%%%%%%%%%%%%%<color=#f4ae34>,*</color>  &%%%</color>")
print("<color=#1a508d>&%%%&       <color=#f4ae34>**</color>%%%%%%%%%%%%%<color=#f4ae34>*****,      **</color>%%%%<color=#f4ae34>**          **</color>%%%%%%%%%%%%%<color=#f4ae34>**</color>  &%%%</color>")
print("<color=#1a508d>&%%%&       <color=#f4ae34>****,**********</color>%%%%<color=#f4ae34>*,      ********          *******,*********</color>  &%%%</color>")
print("<color=#1a508d>&%%%&                    <color=#f4ae34>**####*,</color>                                           &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>&%%%&                                                                       &%%%</color>")
print("<color=#1a508d>@%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%</color>")
print("<color=#1a508d>   &%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%&  </color>")
print("                                                                                ")
print("<color=#182d53>                              &&&&&&&&&&&&&&&&&&&&&                             </color>")
print("<color=#182d53>                              &&&&&&&&&&&&&&&&&&&&&                             </color>")
print("<color=#1a508d>                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                </color>")

ipAddress = params[0]

globals.vulnerabilitiesDirectoryName = "/home/" + active_user + "/vulnerabilities/"
myshell = get_shell
myshell.host_computer.create_folder( "/home/" + active_user, "vulnerabilities")

//#import jsonparser.gs
//#import vuln.gs
//#import tools.gs

//Defining functions

// nmap
// string ipAddress
// @return Port[]
nmap = function(ipAddress)
	isLanIp = is_lan_ip( ipAddress )
	if isLanIp then
		globals.router = get_router;
	else
		globals.router = get_router( ipAddress )
	end if

	if globals.router == null then exit("nmap: ip address not found")

	isRouterIp = globals.router.local_ip == ipAddress
	ports = null

	if not isLanIp or isRouterIp then
		ports = globals.router.used_ports
	else
		ports = globals.router.computer_ports(ipAddress)
	end if

	return ports
end function
// END functions definitions

// finding vulnerabilities for each port
ports = nmap(ipAddress)
print(char(10) + "<color=#FF0000FF>SCANNING ALL PORTS: " + ipAddress + "</color>")
vulnerabilitiesArray = []
scannedLibs = []
// little hack to scan the router with the other libs
ports.push("router")
for port in ports
	if port == "router" then
		lib = getRouter(ipAddress)
	else
		lib = getLib(ipAddress, port)
	end if
	libId = lib.lib_name + "_" + lib.version

	existingVulnerabilityFile = getFile(globals.vulnerabilitiesDirectoryName, libId)
	if (existingVulnerabilityFile != null) then
		print("Vulnerability file '" + libId + "' already existing, skipping")
		continue
	end if

	if (scannedLibs.indexOf(libId) != null) then
		continue
	else
		scannedLibs.push(libId)
	end if
	print("Scanning lib " + libId)
	scanResults = metaxploit.scan(lib)
	// example with port 25, usefull to debug
	//scanResults = ["0x19189A45", "0x1C021A4C", "0x5D601DE4"]
	vulnerabilitiesMap = {}
	for address in scanResults
		vulnerabilitiesMap[address] = metaxploit.scan_address(lib, address)
	end for
	for vulnerabilityByAddr in vulnerabilitiesMap
		addressForThoseVulnerabilitys = vulnerabilityByAddr.key
		vulnerabilitiesLines = vulnerabilityByAddr.value.split("\"+"n")
		vulnerabilityIndex = 0
		vulnerabilitiesToParse = []
		currentVulnerabilityLines = ""
		for vulnerabilityLine in vulnerabilitiesLines
			if vulnerabilityLine.indexOf("Unsafe check") == 0 then
				if vulnerabilityIndex > 0 then
					previousVulnerabilityLine = currentVulnerabilityLines
					vulnerabilitiesToParse.push(previousVulnerabilityLine)
				end if
				vulnerabilityIndex = vulnerabilityIndex + 1
				currentVulnerabilityLines = vulnerabilityLine + "###"
			else if vulnerabilityLine.indexOf("* ") == 0 then
				currentVulnerabilityLines = currentVulnerabilityLines + vulnerabilityLine + "###"
			else
				//print("unused line: " + line)
			end if
		end for// split vulnerabilities
		vulnerabilitiesToParse.push(currentVulnerabilityLines)
		//print("DEBUG To Parse: " + vulnerabilitiesToParse)
		//print("DEBUG addr: " + addressForThoseVulnerabilitys)
		for vulnerability in vulnerabilitiesToParse
			vuln = new Vulnerability
			vuln._setExternalIpAddress(ipAddress)
			vuln._setLibName(lib.lib_name)
			vuln._setPortInfos(port)
			vuln._setVuln(addressForThoseVulnerabilitys, vulnerability)
			vulnerabilitiesArray.push(vuln)
		end for

	end for
end for

for vulnerability in vulnerabilitiesArray
	vulnerabilityFile = vulnerability._toFile
end for

for vulnerability in vulnerabilitiesArray
	myshell = get_shell
	filePath = vulnerability._getFilePath
	fileName = vulnerability.libName + "_" + vulnerability.libVersion + "_" + md5(vulnerability.vulnUnsecValue) + ".json"
	myshell.host_computer.touch(filePath, fileName)

	vulnerabilityFile = myshell.host_computer.File(filePath + fileName)
	vulnerabilityFile.set_content("")
	vulnerabilityFile.set_content(vulnerabilityFile.content + char(10) + toJSON(vulnerability))
end for

print("Vulnerabilities files stored in: " + globals.vulnerabilitiesDirectoryName)
